Eclipse Rich Ajax Platform Release 1.3

## org.eclipse.swt.widgets
Class Spinner

    java.lang.Object
      org.eclipse.swt.widgets.Widget
          org.eclipse.swt.widgets.Control
              org.eclipse.swt.widgets.Scrollable
                  org.eclipse.swt.widgets.Composite
                      org.eclipse.swt.widgets.Spinner

All Implemented Interfaces:
  Adaptable, Drawable

public class Spinner
extends Composite

Instances of this class are selectable user interface objects that allow the user to enter and modify numeric values.

Styles:
  READ_ONLY, WRAP
Events:
  Selection, Modify

IMPORTANT: This class is not intended to be subclassed.

Since:
  1.0

Field Summary
`static int` `LIMIT` the limit for the number of characters that the text field in an instance of this class can hold

Constructor Summary
`Spinner(Composite parent, int style)` Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

Method Summary
`void` `addModifyListener(ModifyListener listener)` Adds the listener to the collection of listeners who will be notified when the receiver's text is modified, by sending it one of the messages defined in the `ModifyListener` interface.
`void` `addSelectionListener(SelectionListener listener)` Adds the listener to the collection of listeners who will be notified when the control is selected by the user, by sending it one of the messages defined in the `SelectionListener` interface.
`Point` `computeSize(int wHint, int hHint, boolean changed)` Returns the preferred size of the receiver.
`Rectangle` `computeTrim(int x, int y, int width, int height)` Given a desired client area for the receiver (as described by the arguments), returns the bounding rectangle which would be required to produce that client area.
`int` `getDigits()` Returns the number of decimal places used by the receiver.
`int` `getIncrement()` Returns the amount that the receiver's value will be modified by when the up/down arrows are pressed.
`int` `getMaximum()` Returns the maximum value which the receiver will allow.
`int` `getMinimum()` Returns the minimum value which the receiver will allow.
`int` `getPageIncrement()` Returns the amount that the receiver's position will be modified by when the page up/down keys are pressed.
`int` `getSelection()` Returns the selection, which is the receiver's position.
`String` `getText()` Returns a string containing a copy of the contents of the receiver's text field, or an empty string if there are no contents.
`int` `getTextLimit()` Returns the maximum number of characters that the receiver is capable of holding.
`void` `removeModifyListener(ModifyListener listener)` Removes the listener from the collection of listeners who will be notified when the receiver's text is modified.
`void` `removeSelectionListener(SelectionListener listener)` Removes the listener from the collection of listeners who will be notified when the control is selected by the user.
`void` `setDigits(int value)` Sets the number of decimal places used by the receiver.
`void` `setIncrement(int value)` Sets the amount that the receiver's value will be modified by when the up/down arrows are pressed to the argument, which must be at least one.
`void` `setMaximum(int value)` Sets the maximum value that the receiver will allow.
`void` `setMinimum(int value)` Sets the minimum value that the receiver will allow.
`void` `setPageIncrement(int value)` Sets the amount that the receiver's position will be modified by when the page up/down keys are pressed to the argument, which must be at least one.
`void` `setSelection(int value)` Sets the selection, which is the receiver's position, to the argument.
`void` `setTextLimit(int textLimit)` Sets the maximum number of characters that the receiver is capable of holding to be the argument.
`void` `setValues(int selection, int minimum, int maximum, int digits, int increment, int pageIncrement)` Sets the receiver's selection, minimum value, maximum value, digits, increment and page increment all at once.

Methods inherited from class org.eclipse.swt.widgets.Composite
`changed, getAdapter, getBackgroundMode, getChildren, getLayout, getLayoutDeferred, getTabList, isLayoutDeferred, layout, layout, layout, layout, layout, setBackgroundMode, setFocus, setLayout, setLayoutDeferred, setTabList`

Methods inherited from class org.eclipse.swt.widgets.Scrollable
`getClientArea, getHorizontalBar, getVerticalBar`

Methods inherited from class org.eclipse.swt.widgets.Control

`addControlListener, addDragDetectListener, addFocusListener, addGestureListener, addHelpListener, addKeyListener, addMenuDetectListener, addMouseListener, addTouchListener, addTraverseListener, computeSize, forceFocus, getAccessible, getBackground, getBackgroundImage, getBorderWidth, getBounds, getCursor, getEnabled, getFont, getForeground, getLayoutData, getLocation, getMenu, getMonitor, getOrientation, getParent, getShell, getSize, getToolTipText, getTouchEnabled, getVisible, isEnabled, isFocusControl, isReparentable, isVisible, moveAbove, moveBelow, pack, pack, redraw, redraw, removeControlListener, removeDragDetectListener, removeFocusListener, removeGestureListener, removeHelpListener, removeKeyListener, removeMenuDetectListener, removeMouseListener, removeTouchListener, removeTraverseListener, setBackground, setBackgroundImage, setBounds, setBounds, setCursor, setEnabled, setFont, setForeground, setLayoutData, setLocation, setLocation, setMenu, setOrientation, setParent, setRedraw, setSize, setSize, setToolTipText, setTouchEnabled, setVisible, toControl, toControl, toDisplay, toDisplay, update`

Methods inherited from class org.eclipse.swt.widgets.Widget
`addDisposeListener, addListener, checkSubclass, checkWidget, dispose, getData, getData, getDisplay, getListeners, getStyle, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, reskin, setData, setData, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### LIMIT

    public static final int LIMIT

  the limit for the number of characters that the text field in an instance of this class can hold

  Since:
    1.3
  See Also:
    Constant Field Values

Constructor Detail

### Spinner

    public Spinner(Composite parent,
                   int style)

  Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

  The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a composite control which will be the parent of the new instance (cannot be null)
  `style` - the style of control to construct
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
  - ERROR_INVALID_SUBCLASS - if this class is not an allowed subclass
See Also:
  `SWT.READ_ONLY`, `SWT.WRAP`, `Widget.checkSubclass()`, `Widget.getStyle()`

Method Detail

### getDigits

    public int getDigits()

  Returns the number of decimal places used by the receiver.

  Returns:
    the digits
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setDigits

    public void setDigits(int value)

  Sets the number of decimal places used by the receiver.

  The digit setting is used to allow for floating point values in the receiver. For example, to set the selection to a floating point value of 1.37 call setDigits() with a value of 2 and setSelection() with a value of 137. Similarly, if getDigits() has a value of 2 and getSelection() returns 137 this should be interpreted as 1.37. This applies to all numeric APIs.

  Parameters:
    `value` - the new digits (must be greater than or equal to zero)
  Throws:
    `IllegalArgumentException` -
    - ERROR_INVALID_ARGUMENT - if the value is less than zero
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    1.3

### getIncrement

    public int getIncrement()

  Returns the amount that the receiver's value will be modified by when the up/down arrows are pressed.

  Returns:
    the increment
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setIncrement

    public void setIncrement(int value)

  Sets the amount that the receiver's value will be modified by when the up/down arrows are pressed to the argument, which must be at least one.

  Parameters:
    `value` - the new increment (must be greater than zero)
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getMinimum

    public int getMinimum()

  Returns the minimum value which the receiver will allow.

  Returns:
    the minimum
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setMinimum

    public void setMinimum(int value)

  Sets the minimum value that the receiver will allow. This new value will be ignored if it is greater than the receiver's current maximum value. If the new minimum is applied then the receiver's selection value will be adjusted if necessary to fall within its new range.

  Parameters:
    `value` - the new minimum, which must be less than or equals to the current maximum
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getMaximum

    public int getMaximum()

  Returns the maximum value which the receiver will allow.

  Returns:
    the maximum
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setMaximum

    public void setMaximum(int value)

  Sets the maximum value that the receiver will allow. This new value will be ignored if it is less than the receiver's current minimum value. If the new maximum is applied then the receiver's selection value will be adjusted if necessary to fall within its new range.

  Parameters:
    `value` - the new maximum, which must be greater than or equal to the current minimum
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getPageIncrement

    public int getPageIncrement()

  Returns the amount that the receiver's position will be modified by when the page up/down keys are pressed.

  Returns:
    the page increment
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setPageIncrement

    public void setPageIncrement(int value)

  Sets the amount that the receiver's position will be modified by when the page up/down keys are pressed to the argument, which must be at least one.

  Parameters:
    `value` - the page increment (must be greater than zero)
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getSelection

    public int getSelection()

  Returns the selection, which is the receiver's position.

  Returns:
    the selection
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setSelection

    public void setSelection(int value)

  Sets the selection, which is the receiver's position, to the argument. If the argument is not within the range specified by minimum and maximum, it will be adjusted to fall within this range.

  Parameters:
    `value` - the new selection (must be zero or greater)
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### setValues

    public void setValues(int selection,
                          int minimum,
                          int maximum,
                          int digits,
                          int increment,
                          int pageIncrement)

  Sets the receiver's selection, minimum value, maximum value, digits, increment and page increment all at once.

  Note: This is similar to setting the values individually using the appropriate methods, but may be implemented in a more efficient fashion on some platforms.

  Parameters:
    `selection` - the new selection value
    `minimum` - the new minimum value
    `maximum` - the new maximum value
    `digits` - the new digits value
    `increment` - the new increment value
    `pageIncrement` - the new pageIncrement value
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

### getText

    public String getText()

  Returns a string containing a copy of the contents of the receiver's text field, or an empty string if there are no contents.

  Returns:
    the receiver's text
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    1.3

### setTextLimit

    public void setTextLimit(int textLimit)

  Sets the maximum number of characters that the receiver is capable of holding to be the argument.

  Instead of trying to set the text limit to zero, consider creating a read-only text widget.

  To reset this value to the default, use `setTextLimit(Text.LIMIT)`. Specifying a limit value larger than `Text.LIMIT` sets the receiver's limit to `Text.LIMIT`.

  Parameters:
    `textLimit` - new text limit
  Throws:
    `IllegalArgumentException` -
    - ERROR_CANNOT_BE_ZERO - if the limit is zero
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    1.3
  See Also:
    `LIMIT`

### getTextLimit

    public int getTextLimit()

  Returns the maximum number of characters that the receiver is capable of holding.

  If this has not been changed by `setTextLimit()`, it will be the constant `Text.LIMIT`.

  Returns:
    the text limit
  Throws:
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    1.3
  See Also:
    `LIMIT`

### computeSize

    public Point computeSize(int wHint,
                             int hHint,
                             boolean changed)

  Description copied from class: `Control`
  Returns the preferred size of the receiver.

  The preferred size of a control is the size that it would best be displayed at. The width hint and height hint arguments allow the caller to ask a control questions such as "Given a particular width, how high does the control need to be to show all of the contents?" To indicate that the caller does not wish to constrain a particular dimension, the constant `SWT.DEFAULT` is passed for the hint.

  If the changed flag is `true`, it indicates that the receiver's contents have changed, therefore any caches that a layout manager containing the control may have been keeping need to be flushed. When the control is resized, the changed flag will be `false`, so layout manager caches can be retained.

  Overrides:
    `computeSize` in class `Composite`

### computeTrim

    public Rectangle computeTrim(int x,
                                 int y,
                                 int width,
                                 int height)

  Description copied from class: `Scrollable`
  Given a desired client area for the receiver (as described by the arguments), returns the bounding rectangle which would be required to produce that client area.

  In other words, it returns a rectangle such that, if the receiver's bounds were set to that rectangle, the area of the receiver which is capable of displaying data (that is, not covered by the "trimmings") would be the rectangle described by the arguments (relative to the receiver's parent).

  Overrides:
    `computeTrim` in class `Scrollable`
  Parameters:
    `x` - the desired x coordinate of the client area
    `y` - the desired y coordinate of the client area
    `width` - the desired width of the client area
    `height` - the desired height of the client area
  Returns:
    the required bounds to produce the given client area
  See Also:
    `Scrollable.getClientArea()`

### addModifyListener

    public void addModifyListener(ModifyListener listener)

  Adds the listener to the collection of listeners who will be notified when the receiver's text is modified, by sending it one of the messages defined in the `ModifyListener` interface.

  Parameters:
    `listener` - the listener which should be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `ModifyListener`, `removeModifyListener(org.eclipse.swt.events.ModifyListener)`

### removeModifyListener

    public void removeModifyListener(ModifyListener listener)

  Removes the listener from the collection of listeners who will be notified when the receiver's text is modified.

  Parameters:
    `listener` - the listener which should no longer be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  See Also:
    `ModifyListener`, `addModifyListener(org.eclipse.swt.events.ModifyListener)`

### addSelectionListener

    public void addSelectionListener(SelectionListener listener)

  Adds the listener to the collection of listeners who will be notified when the control is selected by the user, by sending it one of the messages defined in the `SelectionListener` interface.

  `widgetSelected` is not called for texts. `widgetDefaultSelected` is typically called when ENTER is pressed in a single-line text.

  Parameters:
    `listener` - the listener which should be notified when the control is selected by the user
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    1.2
  See Also:
    `SelectionListener`, `removeSelectionListener(org.eclipse.swt.events.SelectionListener)`, `SelectionEvent`

### removeSelectionListener

    public void removeSelectionListener(SelectionListener listener)

  Removes the listener from the collection of listeners who will be notified when the control is selected by the user.

  Parameters:
    `listener` - the listener which should no longer be notified
  Throws:
    `IllegalArgumentException` -
    - ERROR_NULL_ARGUMENT - if the listener is null
    `SWTException` -
    - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
    - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  Since:
    1.2
  See Also:
    `SelectionListener`, `addSelectionListener(org.eclipse.swt.events.SelectionListener)`

Eclipse Rich Ajax Platform Release 1.3

Copyright (c) Innoopract Informationssysteme GmbH and others 2002, 2011. All rights reserved.